# This file was auto-generated by Fern from our API Definition.

import datetime as dt
import typing

from ....core.datetime_utils import serialize_datetime
from ....core.pydantic_utilities import pydantic_v1
from ....core.unchecked_base_model import UncheckedBaseModel


class TrainingStepMetrics(UncheckedBaseModel):
    """
    The evaluation metrics at a given step of the training of a fine-tuned model.
    """

    created_at: typing.Optional[dt.datetime] = pydantic_v1.Field(default=None)
    """
    Creation timestamp.
    """

    step_number: typing.Optional[int] = pydantic_v1.Field(default=None)
    """
    Step number.
    """

    metrics: typing.Optional[typing.Dict[str, float]] = pydantic_v1.Field(default=None)
    """
    Map of names and values for each evaluation metrics.
    """

    def json(self, **kwargs: typing.Any) -> str:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().json(**kwargs_with_defaults)

    def dict(self, **kwargs: typing.Any) -> typing.Dict[str, typing.Any]:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().dict(**kwargs_with_defaults)

    class Config:
        frozen = True
        smart_union = True
        extra = pydantic_v1.Extra.allow
        json_encoders = {dt.datetime: serialize_datetime}
