# This file was auto-generated by Fern from our API Definition.

import datetime as dt
import typing

from ..core.datetime_utils import serialize_datetime
from ..core.pydantic_utilities import pydantic_v1
from .generate_stream_event import GenerateStreamEvent


class GenerateStreamText(GenerateStreamEvent):
    text: str = pydantic_v1.Field()
    """
    A segment of text of the generation.
    """

    index: typing.Optional[int] = pydantic_v1.Field(default=None)
    """
    Refers to the nth generation. Only present when `num_generations` is greater than zero, and only when text responses are being streamed.
    """

    is_finished: bool

    def json(self, **kwargs: typing.Any) -> str:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().json(**kwargs_with_defaults)

    def dict(self, **kwargs: typing.Any) -> typing.Dict[str, typing.Any]:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().dict(**kwargs_with_defaults)

    class Config:
        frozen = True
        smart_union = True
        allow_population_by_field_name = True
        populate_by_name = True
        extra = pydantic_v1.Extra.allow
        json_encoders = {dt.datetime: serialize_datetime}
